#property copyright ""
#property link      ""


#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  Silver
#property indicator_color2  Silver
#property indicator_color3  Green
#property indicator_color4  Red
#property indicator_color5  Red
#property indicator_color6  Blue
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  3
#property indicator_width4  3
#property indicator_width5  3

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    FastMa          = 12;
extern int    FastMaMode      = MODE_EMA;
extern int    SlowMa          = 26;
extern int    SlowMaMode      = MODE_EMA;
extern int    SignalMa        = 9;
extern int    SignalMaMode    = MODE_SMA;
extern int    MacdPrice       = PRICE_CLOSE;
extern int    Shift           = 0;

extern string _               = "alerts settings";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;

//
//
//
//
//

double Macd_Buffer[];
double Signal_Buffer[];
double Green_Buffer[];
double Red_Buffer[];
double macdDn[]; 
double macdUp[]; 
double signal[];
double trend1[];
double trend2[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init() 
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,macdDn); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,macdUp); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Macd_Buffer);
   SetIndexBuffer(3,Green_Buffer);
   SetIndexBuffer(4,Red_Buffer);
   SetIndexBuffer(5,Signal_Buffer);
   SetIndexBuffer(6,trend1);
   SetIndexBuffer(7,trend2);
   
      FastMa   = MathMax(FastMa,1);
      SlowMa   = MathMax(SlowMa,1);
      SignalMa = MathMax(SignalMa,1);

      //
      //
      //
      //
      //
      //
   
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame == "returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame == "calculateValue"); if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);   
      for (int i=0; i<6; i++) SetIndexShift(i,Shift*timeFrame/Period());

      //
      //
      //
      //
      //
   
  IndicatorShortName(timeFrameToString(timeFrame)+" MACD Alert2 ("+FastMa+","+SlowMa+","+SignalMa+")");
  SetIndexLabel(0, "MACD");
  SetIndexLabel(1, "MACD");
  SetIndexLabel(2, "MACD");
  SetIndexLabel(3, "Green");
  SetIndexLabel(4, "Red");
  SetIndexLabel(5, "Signal");
return(0);
}
   
int deinit() {   return (0); }

//
//
//
//
//

int start() 
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { macdDn[0] = limit+1; return(0); }
   
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
     if (trend2[limit]==-1)   CleanPoint(limit,Green_Buffer,Red_Buffer);
     for(i=limit; i>=0; i--) Macd_Buffer[i]   = iMA(NULL,0,FastMa,0,FastMaMode,MacdPrice,i) - iMA(NULL,0,SlowMa,0,SlowMaMode,MacdPrice,i);
     for(i=limit; i>=0; i--) Signal_Buffer[i] = iMAOnArray(Macd_Buffer,0,SignalMa,0,SignalMaMode,i);
     for(i=limit; i>=0; i--) 
     {
        macdDn[i]       = EMPTY_VALUE;
        macdUp[i]       = EMPTY_VALUE;
        Red_Buffer[i]   = EMPTY_VALUE;
        Green_Buffer[i] = EMPTY_VALUE;
        trend1[i] = trend1[i+1];
        trend2[i] = trend2[i+1];
        if (Macd_Buffer[i]>0)                trend1[i] = 1;
        if (Macd_Buffer[i]<0)                trend1[i] =-1;
        if (Macd_Buffer[i]>Signal_Buffer[i]) trend2[i] = 1;
        if (Macd_Buffer[i]<Signal_Buffer[i]) trend2[i] =-1;
        if (trend1[i] == 1) macdUp[i] = Macd_Buffer[i]; 
        if (trend1[i] ==-1) macdDn[i] = Macd_Buffer[i]; 
        if (trend2[i] ==-1) PlotPoint(i,Green_Buffer,Red_Buffer,Macd_Buffer);
    }     
    manageAlerts();
   return (0);
   }
   
   //
   //
   //
   //
   //
      
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (trend2[limit]==-1)   CleanPoint(limit,Green_Buffer,Red_Buffer);
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);  
         macdDn[i]        = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMode,SlowMa,SlowMaMode,SignalMa,SignalMaMode,MacdPrice,0,0,y);
         macdUp[i]        = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMode,SlowMa,SlowMaMode,SignalMa,SignalMaMode,MacdPrice,0,1,y);
         Macd_Buffer[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMode,SlowMa,SlowMaMode,SignalMa,SignalMaMode,MacdPrice,0,2,y);
         Red_Buffer[i]    = EMPTY_VALUE;
         Green_Buffer[i]  = EMPTY_VALUE;
         Signal_Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMode,SlowMa,SlowMaMode,SignalMa,SignalMaMode,MacdPrice,0,5,y);
         trend1[i]        = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMode,SlowMa,SlowMaMode,SignalMa,SignalMaMode,MacdPrice,0,6,y);
         trend2[i]        = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaMode,SlowMa,SlowMaMode,SignalMa,SignalMaMode,MacdPrice,0,7,y);          
   }
   for (i=limit;i>=0;i--) if (trend2[i] == -1) PlotPoint(i,Green_Buffer,Red_Buffer,Macd_Buffer);
   manageAlerts();
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend2[whichBar]!= trend2[whichBar+1])
      {
        if (trend2[whichBar] == 1) doAlert(whichBar," Long signal!");
        if (trend2[whichBar] ==-1) doAlert(whichBar," Short signal!");
      }         
     
    } 
            
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," MACD ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," MACD"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

